#import "NSMutableData+Parse.h"


@implementation NSMutableData( Parse)

//
// do a lame two pass algorithm
//
static unsigned int lengthOfParsedData( unsigned char *s)
{
   unsigned int  len;

   len = 0;
   if( ! *s)
      return( len);
   if( *s != '<')
      return( len);
   ++s;
   for(;;)
   {
      switch( toupper( *s++))
      {
      case '0' :
      case '1' :
      case '2' :
      case '3' :
      case '4' :
      case '5' :
      case '6' :
      case '7' :
      case '8' :
      case '9' :
      case 'A' :
      case 'B' :
      case 'C' :
      case 'D' :
      case 'E' :
      case 'F' :
         len++;
         break;
         
      case ' ' :
         if( len & 1)
            return( 0);
         continue;
      case '>' :
         if( len & 1)
            return( 0);
         return( len >> 1);
         
      default :
         return( 0);		// humorless
      }
   }
   return( 0);
}


static unsigned char   lut[ 128] =
{
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,	// $10
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,	// $20
   0, 1, 2, 3, 4, 5, 6, 7,  8, 9, 0, 0, 0, 0, 0, 0,	// $30
   0,10,11,12,13,14,15, 0,  0, 0, 0, 0, 0, 0, 0, 0,	// $40
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,	
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0
};


static void   parseDescriptionIntoBufferOfLength( unsigned char *s,
                                                  unsigned char *dst,
                                                  unsigned int len)
{
   unsigned char  val;
   unsigned char  c;
   
   for( ;len;)
   {
      switch( c = toupper( *s++))
      {
      default  :
         val  = lut[ c] << 4;
         c    = toupper( *s++);
         val |= lut[ c];
         *dst++ = val;
         len--;
         break;

      case ' ' :
      case '<' :
      case '>' :
         continue;  // !!
      }
   }
}


- (id) initWithDescription:(NSString *) string
{
   unsigned char  *s;
   unsigned int  len;

//
// lucky for us the description is plain ASCII..
//
   s = (unsigned char *) [string lossyCString];
   while( *s && isspace( *s))
      s++;
   len = lengthOfParsedData( s);
   if( len == 0)
   {
      [self dealloc];		// waste alloc
      return( nil);
   }
   
   //
   // evil stuff...
   //
   self = [self initWithLength:len];  
   parseDescriptionIntoBufferOfLength( s, (void *) [self mutableBytes], len);
   return( self);
}


+ dataWithDescription:(NSString *) string
{
   return( [[[self alloc] initWithDescription:string] autorelease]);
}
@end
